#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "protocol.h"
#include "server_socket.h"
#include "prim_calc.h"

#ifndef MIN
#define MIN(x,y)      ((x)<(y) ? (x) : (y))
#endif

#define BUFSIZE 1024
char *response = "HTTP/1.0 200 OK\r\nContent-Type: text/html\r\nConnection: close\r\n\r\n";

int main()
{
  int client_socket;

  char buf[BUFSIZE] = {0};

  int arg, cmd, res;

  struct server_info *server;

  server = new_server_socket( TCP_PORT );
  bind_socket( server);

  do {
    client_socket =  wait_for_client( server );

    do {
      res = recv(client_socket, buf, BUFSIZE, 0);
      //printf("Recv: %d byte\n",res);
      get_cmd_url(buf, BUFSIZE, &cmd, &arg);
	    res = arg; // res = byte left to send/read from file
  
      if( cmd == CMD_FILETRANSFER ) {
        printf("Filetransfer: %d\n",res);

        send(client_socket, response, strlen(response), 0);

        FILE *file;
        file = fopen ("bigdata","r");

				while (res != 0) {
					// Read data into buffer.  We may not have enough to fill up buffer, so we
					// store how many bytes were actually read in bytes_read.
					int bytes_read = fread(buf, 1, MIN(BUFSIZE, res), file);
					//printf("Read: %d\n",bytes_read);
					if (bytes_read == 0) // We're done reading from the file
						break;

					if (bytes_read < 0) {
						fprintf(stderr,"ERROR reading from file"); 
					}

          res -= bytes_read;
          //printf("Res: %d\n",res);

					// You need a loop for the write, because not all of the data may be written
					// in one call; write will return how many bytes were written. p keeps
					// track of where in the buffer we are, while we decrement bytes_read
					// to keep track of how many bytes are left to write.
					void *p = buf;
					while (bytes_read > 0) {
						int bytes_written = write(client_socket, buf, bytes_read);
						if (bytes_written <= 0) {
							fprintf(stderr,"ERROR writing to socket\n");
						}
						bytes_read -= bytes_written;
						p += bytes_written;
					}
				}
  			fclose(file);
  			
        shutdown(client_socket, SHUT_WR);
        break;
      } else if ( cmd == CMD_CALCULATION ) {
        res = biggest_prim(arg);
        printf("Calculate: %d -> %d\n",arg,res);
        send(client_socket, response, strlen(response), 0);
        shutdown(client_socket, SHUT_WR);
        break;
      } else {
        send(client_socket, response, strlen(response), 0);
        close(client_socket);

#ifndef NOHTTP
        shutdown(client_socket, SHUT_WR);
        close_server_socket(server);
        exit(0);
#endif

        break;
      }
    } while(1);
  } while(1);

  close_server_socket(server);
}

